// AraKlipDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AraKlip.h"
#include "AraKlipDlg.h"
#include "ConfigureDialog.h"
#include "Registry.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_ICON_NOTIFY			WM_USER+10
#define SCAN_INTERVAL			1000
#define SCAN_TIMER_ID			1

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_license;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_license = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_LICENSE, m_license);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetDlgItemText(IDC_LICENSE,
"Redistribution and use in source and binary forms, with or without modification," \
"are permitted provided that the following conditions are met:\n" \
"\n" \
"1. Redistributions of source code must retain the above copyright notice, this " \
"list of conditions and the following disclaimer.\n" \
"" \
"2. Redistributions in binary form must reproduce the above copyright notice, " \
"this list of conditions and the following disclaimer in the documentation and/or " \
"other materials provided with the distribution.\n" \
"" \
"3. Neither the name of the author nor the names of its contributors may be used " \
"to endorse or promote products derived from this software without specific prior " \
"written permission.\n" \
"\n" \
"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND " \
"ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED " \
"WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE " \
"DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR " \
"ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES " \
"(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; " \
"LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON " \
"ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT " \
"(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS " \
"SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."); \
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CAraKlipDlg dialog

CAraKlipDlg::CAraKlipDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAraKlipDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAraKlipDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_ignore = 0;
}

void CAraKlipDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAraKlipDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAraKlipDlg, CDialog)
	//{{AFX_MSG_MAP(CAraKlipDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_COMMAND(ID_MENU_QUIT, OnMenuQuit)
	ON_COMMAND(ID_MENU_CONFIGURE, OnMenuConfigure)
	ON_COMMAND(ID_MENU_ABOUT, OnMenuAbout)
	ON_COMMAND(ID_LPOP_CLEAR, OnLpopClear)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_ICON_NOTIFY, OnTrayNotification)
	ON_MESSAGE(WM_DRAWCLIPBOARD, OnDrawClipboard)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAraKlipDlg message handlers

BOOL CAraKlipDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetClipboardViewer();

	CRegistry reg;

	if(!reg.VerifyKey(REGREPOSITORY, REGPATH))
		m_conf.DoModal();

	m_conf.LoadConf(0);
	m_udlg.Create(IDD_LAUNCH_DIALOG, this);
	m_udlg.SetWindowType(m_conf.m_urlwait * 1000, m_conf.m_launchtype);
	m_cqueue.resize(m_conf.m_history);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAraKlipDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

LRESULT CAraKlipDlg::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
    // Delegate all the work back to the default implementation in CTrayIcon.
    return m_TrayIcon.OnTrayNotification(wParam, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAraKlipDlg::OnPaint()
{
	static int first=1;

	if (first) {
		ShowWindow(SW_HIDE);
		first = 0;
	}

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAraKlipDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CAraKlipDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	HICON hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	if (!m_TrayIcon.Create(this, WM_ICON_NOTIFY, "AraKlip", hIcon, IDR_RIGHTPOP))
	{
		AfxMessageBox(_T("Failed to create tray icon"), MB_OK | MB_ICONSTOP);
		return -1;
	}
	m_TrayIcon.SetQueue(&m_cqueue);
	
	return 0;
}

BOOL CAraKlipDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style &= ~WS_VISIBLE;

	return CDialog::PreCreateWindow(cs);
}

void CAraKlipDlg::OnMenuQuit() 
{
	OnOK();	
}


LRESULT CAraKlipDlg::OnDrawClipboard(WPARAM wParam, LPARAM lParam)
{
	static bool first=1;

	if(OpenClipboard())
	{
		char *buff;
		buff = (char*) GetClipboardData(CF_TEXT);
		CloseClipboard();
		
		if (buff) {
			if (!first && m_conf.m_url_use) {
				if (m_conf.m_url_http && !strncmp(buff, "http://", 7) )
					m_udlg.SetNewURL("http", buff);
				else if (m_conf.m_url_http && !strncmp(buff, "https://", 8) )
					m_udlg.SetNewURL("https", buff);
				else if (m_conf.m_url_ftp && !strncmp(buff, "ftp://", 6) )
					m_udlg.SetNewURL("ftp", buff);
				else if (m_conf.m_url_mail && !strncmp(buff, "mailto:", 7) )
					m_udlg.SetNewURL("mailto", buff);
				else if (m_conf.m_url_mailstring && CheckMailString(buff) )
					m_udlg.SetNewURL("mailto", buff);
				else if (m_conf.m_url_mms && !strncmp(buff, "mms://", 6) )
					m_udlg.SetNewURL("MMS", buff);
			}
			
			if (!m_ignore) {
				m_cqueue.add(buff);
			} else
				m_ignore--;
/*			CString m;
			m.Format("Now Contains %d", m_cqueue.get_length());
			AfxMessageBox(m);*/
		}
	}
	
	first = 0;
    return 1;
}

void CAraKlipDlg::OnMenuConfigure() 
{
	m_conf.DoModal();
	m_udlg.SetWindowType(m_conf.m_urlwait * 1000, m_conf.m_launchtype);
	m_cqueue.resize(m_conf.m_history);
}

bool CAraKlipDlg::CheckMailString(char *str)
{
	char *s = str;
	bool invalid=false;
	int atnum = 0;

	while (*s && atnum <= 1) {
		if (*s == '@')
			atnum ++;
		else if ( !(('A' <= *s && *s <= 'Z') ||
					('a' <= *s && *s <= 'z') ||
					('0' <= *s && *s <= '9') ||
					*s == '_' || *s == '.' || *s == '-') ) {
			invalid = true;
			break;
		}

		s++;
	}
	if ((atnum != 1) || (s - str == 0))
		invalid = true;

	return !invalid;
}

void CAraKlipDlg::OnMenuAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CAraKlipDlg::OnLpopClear() 
{
	m_cqueue.clear();	
}

BOOL CAraKlipDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (wParam >= ID_LPOP_BUFFER_MIN && wParam <= ID_LPOP_BUFFER_MAX) {
		m_cqueue.selected = m_cqueue.get_length() - (wParam - ID_LPOP_BUFFER_MIN) - 1;
		SetClipboard(m_cqueue.getitem(wParam - ID_LPOP_BUFFER_MIN));
	}
	return CDialog::OnCommand(wParam, lParam);
}

void CAraKlipDlg::SetClipboard(const char *str)
{
	char *buffer;
	if(OpenClipboard())
	{
		HGLOBAL clipbuffer;
		EmptyClipboard();
		clipbuffer=GlobalAlloc(GMEM_DDESHARE, strlen(str)+1);
		buffer=(char*)GlobalLock(clipbuffer);
		strcpy(buffer,str);
		m_ignore++;
		GlobalUnlock(clipbuffer);
		SetClipboardData(CF_TEXT,clipbuffer);
		CloseClipboard();
	}
}
