// ConfigureDialog.cpp : implementation file
//

#include "stdafx.h"
#include "AraKlip.h"
#include "ConfigureDialog.h"
#include "Registry.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigureDialog dialog


CConfigureDialog::CConfigureDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigureDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigureDialog)
	m_google = TRUE;
	m_history = 10;
	m_clipmenu = TRUE;
	m_launchtype = 0;
	m_urlwait = 5;
	m_service = FALSE;
	m_url_ftp = TRUE;
	m_url_http = TRUE;
	m_url_mail = TRUE;
	m_url_mailstring = TRUE;
	m_url_mms = TRUE;
	m_url_use = TRUE;
	//}}AFX_DATA_INIT
}


void CConfigureDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigureDialog)
	DDX_Check(pDX, IDC_CLIP_GOOGLE, m_google);
	DDX_Text(pDX, IDC_CLIP_HISTORY, m_history);
	DDV_MinMaxInt(pDX, m_history, 1, 30);
	DDX_Check(pDX, IDC_CLIP_MENU, m_clipmenu);
	DDX_CBIndex(pDX, IDC_COMBO_LAUNCH, m_launchtype);
	DDX_Text(pDX, IDC_EDIT_URLWAIT, m_urlwait);
	DDV_MinMaxInt(pDX, m_urlwait, 1, 60);
	DDX_Check(pDX, IDC_RUNSERVICE, m_service);
	DDX_Check(pDX, IDC_URL_FTP, m_url_ftp);
	DDX_Check(pDX, IDC_URL_HTTP, m_url_http);
	DDX_Check(pDX, IDC_URL_MAIL, m_url_mail);
	DDX_Check(pDX, IDC_URL_MAILSTRING, m_url_mailstring);
	DDX_Check(pDX, IDC_URL_MMS, m_url_mms);
	DDX_Check(pDX, IDC_URL_USE, m_url_use);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigureDialog, CDialog)
	//{{AFX_MSG_MAP(CConfigureDialog)
	ON_BN_CLICKED(IDC_URL_USE, OnUrlUse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigureDialog message handlers
void CConfigureDialog::SaveConf()
{
	UpdateData(TRUE);

	CRegistry reg;
	
	if(!reg.VerifyKey(REGREPOSITORY, REGPATH))
		reg.CreateKey(REGREPOSITORY, REGPATH);

	reg.Open(REGREPOSITORY, REGPATH);

	reg.Write("UseGoogle",		m_google);
	reg.Write("History",		m_history);
	reg.Write("UseClipMenu",	m_clipmenu);
	reg.Write("LaunchType",		m_launchtype);
	reg.Write("UrlWait",		m_urlwait);
	reg.Write("UrlFTP",			m_url_ftp);
	reg.Write("UrlHTTP",		m_url_http);
	reg.Write("UrlMail",		m_url_mail);
	reg.Write("UrlMailString",	m_url_mailstring);
	reg.Write("UrlMMS",			m_url_mms);
	reg.Write("UseURLLaunch",	m_url_use);

	reg.Write("RunService",		m_service);

	reg.Close();

	SyncRunAtBoot(TRUE);
}

void CConfigureDialog::LoadConf(int updlg)
{
	CRegistry reg;
	
	if(!reg.VerifyKey(REGREPOSITORY, REGPATH))
		return;

	reg.Open(REGREPOSITORY, REGPATH);

	reg.Read("UseGoogle",		m_google);
	reg.Read("History",			m_history);
	reg.Read("UseClipMenu",		m_clipmenu);
	reg.Read("LaunchType",		m_launchtype);
	reg.Read("UrlWait",			m_urlwait);
	reg.Read("UrlFTP",			m_url_ftp);
	reg.Read("UrlHTTP",			m_url_http);
	reg.Read("UrlMail",			m_url_mail);
	reg.Read("UrlMailString",	m_url_mailstring);
	reg.Read("UrlMMS",			m_url_mms);
	reg.Read("UseURLLaunch",	m_url_use);

	reg.Read("RunService",		m_service);

	reg.Close();
	
	SyncRunAtBoot(FALSE);

	if (updlg)
		UpdateData(FALSE);
}

void CConfigureDialog::SyncRunAtBoot(BOOL SaveAndValidate)
{
	CRegistry reg;
	
	if(!reg.VerifyKey(REGREPOSITORY, RUNREGPATH))
		reg.CreateKey(REGREPOSITORY, RUNREGPATH);

	reg.Open(REGREPOSITORY, RUNREGPATH);
	
	if (SaveAndValidate) {
		if (m_service)
			reg.Write(RUNSERVICE_NAME, ::GetCommandLine());
		else
			reg.DeleteValue(RUNSERVICE_NAME);
	} else
		m_service = reg.VerifyValue(RUNSERVICE_NAME);

	reg.Close();
}

BOOL CConfigureDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	LoadConf(1);
	SyncUrlUse();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigureDialog::OnOK() 
{
	SaveConf();
	
	CDialog::OnOK();
}

void CConfigureDialog::OnUrlUse() 
{
	UpdateData(TRUE);
	SyncUrlUse();	
	UpdateData(FALSE);
}

void CConfigureDialog::SyncUrlUse()
{
	if (m_url_use) {
		GetDlgItem(IDC_URL_HTTP)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_FTP)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_MAIL)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_MAILSTRING)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_MMS)->EnableWindow(TRUE);
		GetDlgItem(IDC_COMBO_LAUNCH)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_URLWAIT)->EnableWindow(TRUE);
	} else {
		GetDlgItem(IDC_URL_HTTP)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_FTP)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_MAIL)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_MAILSTRING)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_MMS)->EnableWindow(FALSE);
		GetDlgItem(IDC_COMBO_LAUNCH)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_URLWAIT)->EnableWindow(FALSE);
	}
}
