// LaunchDialog.cpp : implementation file
//

#include "stdafx.h"
#include "AraKlip.h"
#include "LaunchDialog.h"
#include "UrlEditDlg.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define AUTOHIDE_TIMERID 929

/////////////////////////////////////////////////////////////////////////////
// CLaunchDialog dialog


CLaunchDialog::CLaunchDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CLaunchDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLaunchDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hidetime = 3000;
	m_position = 1;
}


void CLaunchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLaunchDialog)
	DDX_Control(pDX, IDC_LAUNCH_CANCEL, mc_cancel);
	DDX_Control(pDX, IDC_LAUNCH_EDIT, mc_edit);
	DDX_Control(pDX, IDC_LAUNCH_EXEC, mc_exec);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLaunchDialog, CDialog)
	//{{AFX_MSG_MAP(CLaunchDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_LAUNCH_CANCEL, OnLaunchCancel)
	ON_BN_CLICKED(IDC_LAUNCH_EXEC, OnLaunchExec)
	ON_BN_CLICKED(IDC_LAUNCH_EDIT, OnLaunchEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLaunchDialog message handlers

BOOL CLaunchDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLaunchDialog::StartHideTimer()
{
	KillTimer(AUTOHIDE_TIMERID);
	SetTimer(AUTOHIDE_TIMERID, m_hidetime, NULL);
}

void CLaunchDialog::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == AUTOHIDE_TIMERID) {
		ShowWindow(SW_HIDE);
		KillTimer(AUTOHIDE_TIMERID);
	}

	CDialog::OnTimer(nIDEvent);
}

void CLaunchDialog::SetWindowType(int hidetime, int position)
{
	m_hidetime = hidetime;
	m_position = position;
}

void CLaunchDialog::SetNewURL(const char *type, const char *dest)
{
	m_udest = dest;
	m_utype = type;

	CRect rectWorkArea, windrect;
	SystemParametersInfo(SPI_GETWORKAREA,
					   0,
					   (LPVOID)&rectWorkArea,
					   0);
	int cx = rectWorkArea.Width();
	int cy = rectWorkArea.Height();
	
	GetWindowRect(&windrect);
	int sizex = windrect.right - windrect.left;
	int sizey = windrect.bottom - windrect.top;

	CPoint curs;
	GetCursorPos(&curs);

	switch (m_position) {
	case 0: // right bottom on screen
		windrect.right = cx;
		windrect.left  = cx - sizex;
		windrect.bottom = cy;
		windrect.top    = cy - sizey;
		break;
	case 1: // right bottom of cursor
		windrect.left = curs.x;
		windrect.top  = curs.y;
		windrect.right = curs.x + sizex;
		windrect.bottom = curs.y + sizey;
		if (windrect.right > cx) {
			windrect.left -= sizex;
			windrect.right -= sizex;
		}
		if (windrect.bottom > cy) {
			windrect.top -= sizey;
			windrect.bottom -= sizey;
		}
		break;
	case 2: // center on screen
		windrect.right = (cx + sizex) / 2;
		windrect.left  = (cx - sizex) / 2;
		windrect.bottom = (cy + sizey) / 2;
		windrect.top    = (cy - sizey) / 2;
		break;
	}

	::SetWindowPos(m_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW);
	MoveWindow (&windrect, TRUE);

	ShowWindow(SW_SHOWNA);
	StartHideTimer();
}

void CLaunchDialog::OnLaunchCancel() 
{
	ShowWindow(SW_HIDE);
}

void CLaunchDialog::OnLaunchExec() 
{
	ShowWindow(SW_HIDE);
	LaunchBrowser(m_utype, m_udest);
}

void CLaunchDialog::OnLaunchEdit() 
{
	ShowWindow(SW_HIDE);

	CUrlEditDlg dlg(m_udest);
	if (dlg.DoModal() == IDOK) {
		const char *type;
		type = GetURLType(dlg.m_url);
		if (type)
			LaunchBrowser(type, dlg.m_url.GetBuffer(2));
	}
}
